#######################################################################################
# File: 			totd.tcl
# Purpose:			Tip of the Day for Ticol autoexec.tcl (include file)
# Language:			Ticol Tcl v1.26+
#
# Versions:
# 1.00 22/Oct/2019	First version
#######################################################################################
# Notes:
# Ported to Ticol Tcl 24/Sep/2019 from 30+ year old BASIC code
# ADD Get year from command line
#######################################################################################
/* ORIGINAL 8-bit PCW Z80 code
1 'Mallard(TM) BASIC PC-Calendar - (Unknown Author 1986) Modified 01-07-1991
10 CLEAR 
20 DIM m$(12):DIM m(12) :DIM b(12)
30 INPUT"Send a copy to disc file ? - (Y/N) ";pt$:pt$=UPPER$(pt$)
40 IF pt$="Y" THEN pt=1 ELSE pt=0
45 IF pt=1 THEN INPUT"Enter drive A-B-C";drive$:drive$=UPPER$(drive$):IF INSTR("ABC",drive$)=0 THEN GOTO 45
50 INPUT"Enter calendar year required> ",y
60 INPUT"Enter title >",t$
70 IF t$=""THEN t$="Foobar Computer Software"
75 leng=LEN(t$):c=leng/2:z=38-c

80 l=y-3+INT((y+3)/4)
90 e=-(l-7*INT(l/7))
100 FOR c=1 TO 12:IF c<8 THEN READ d$(c)
110 READ m$(c):READ m(c) :IF INT(y/4)=y/4 THEN m(2)=1
120 e=e-m(c-1) :b(c)=e+(7 AND e < -5)
130 e=b(c) 
140 NEXT c
145 IF pt=1 THEN OPEN"o",1,drive$+":"+STR$(y)+".cal"
150 :
160 PRINT TAB(z);t$:PRINT:PRINT
170 IF pt THEN PRINT #1, TAB(z);t$ :PRINT #1,:PRINT #1,
180 PRINT TAB(34)"C A L E N D A R ";y
190 IF pt THEN PRINT #1, TAB(28)"C A L E N D A R ";y 
200 PRINT 
210 IF pt THEN PRINT #1,
220 n=1
230 FOR c=1 TO 6
240 PRINT TAB(18) m$(n);TAB(51) m$(n+1)
250 IF pt THEN PRINT #1, TAB(18) m$(n);TAB(51) m$(n+1)
260 FOR w=1 TO 7
270 p=1 :x=0 :a=10:t=16 
280 FOR h= 1 TO 2
290 d=b(n+x)+(w-1)
300 PRINT TAB(a);d$(w);"...";
310 IF pt THEN PRINT #1, TAB(a);d$(w);"...";
320 FOR p=1 TO 6
330 IF d < 1 OR d > 28+m(n+x) THEN 360
340 PRINT TAB(t);d;
350 IF pt THEN PRINT #1, TAB(t);d;
360 t=t+4 :d=d+7
370 NEXT p
380 x=1 :a=43 :t=49
390 NEXT h
400 PRINT 
410 IF pt THEN PRINT #1,
420 NEXT w
430 PRINT 
440 IF pt THEN PRINT #1,
450 n=n+2
460 NEXT c
465 CLOSE
470 PRINT"Repeat ? (Y/N) ";:q$=UPPER$(INPUT$(1)):IF q$="Y"THEN GOTO 160 ELSE RUN
480 :
490 DATA Sun,January,3,Mon,February,0,Tue,March,3,Wed,April
500 DATA 2,Thu,May,3,Fri,June,2,Sat,July,3,August,3
510 DATA September,2,October,3,November,2,December,3	*/
#######################################################################################

option expression off

array set d {
	1	Sun
	2	Mon
	3	Tue
	4	Wed
	5	Thu
	6	Fri
	7	Sat
}

array set m {
	1	January
	2	February
	3	March
	4	April
	5	May
	6	Jun
	7	July
	8	August
	9	September
	10	October
	11	November
	12	December
}

array set em {
	0	0	# required due to invalid array access
	1	3
	2	0
	3	3
	4	2
	
	5	3
	6	2
	7	3
	8	3

	9	2
	10	3
	11	2
	12	3
}

array set b {		# DIM b(12) (BASIC OPTION BASE 0)
	0 0
	1 0
	2 0
	3 0
	4 0
	5 0
	6 0
	7 0
	8 0
	9 0
	10 0
	11 0
	12 0
}

cls

set year [date -year]
newline
set title "C A L E N D A R - $year"
set length [string length $title]
set c [/ $length 2]
set z [- [/ [console width] 2] $c]
set l [+ [- $year 3] [/ [+ $year 3] 4]]							# 80 l=y-3+INT((y+3)/4)
set e -[- $l [* 7 [/ $l 7]]]									# 90 e=-(l-7*INT(l/7)) BEDMAS?

/* TESTS
if {== $year 1986} {assert $l {== $_ 2480}}
if {== $year 1986} {assert $e {== $_ -2}}						# */

for {set c 1} {<= $c 12} {++ c} {								# 100 FOR c=1 TO 12
	if {[== [/ $year 4.0] [/ $year 4]]} {						# 110 IF INT(y/4)=y/4
		set em(2) 1												# 120 m(2)=1
	}
	-= e $em([- $c 1])											# 120 e=e-m(c-1)  (Caution: INDEXES m(0))
	set b($c) [+ $e [& 7 [sbool [< $e -5]]]]					# 120 b(c)=e+(7 AND e < -5)
	set e $b($c)												# 130 e=b(c)
}

textcolor yellow
puts "[tab $z]$title"											# 160 PRINT TAB(z);t$:PRINT:PRINT
textcolor
newline
set n 1															# 220 n=1
for {set c 1} {<= $c 6} {++ c} {								# 230 FOR c=1 TO 6 (6 x month pairs)
	textcolor yellow
	printf "[tab 9]%-9s[tab 24]%-9s\n" $m($n) $m([+ $n 1])		# 240 PRINT TAB(18) m$(n);TAB(51) m$(n+1)
	textcolor
	for {set w 1} {<= $w 7} {++ w} {							# 260 FOR w=1 TO 7  (7 weekdays)
		set p 1													# 270 p=1 :x=0 :a=10:t=16 
		set x 0
		set a 10												# a advance
		set t 16												# t indent
		for {set h 1} {<= $h 2} {++ h} {						# 280 FOR h= 1 TO 2
			set dd [+ $b([+ $n $x]) [- $w 1]] 					# 290 d=b(n+x)+(w-1)
			gotoxy $a [console cury]								# 300 PRINT TAB(a); ...
			printf "%3s..." $d($w)								# ... d$(w);"...";  (day name...)
			for {set p 1} {<= $p 6} {++ p} {					# 320 FOR p=1 TO 6
				if {|| [< $dd 1] [> $dd [+ $em([+ $n $x]) 28]  ]} {		# IF d < 1 OR d > 28+m(n+x) THEN 360
					+= t 4										# 360 t=t+4 :d=d+7
					+= dd 7										# ...
				 	continue									# 370
				}
				gotoxy $t [console cury]							# PRINT TAB(t); ...
				printf "%4s" $dd								# d;  (print the day number)
				+= t 4
				+= dd 7
			}
			set x 1												# 380 x=1 :a=43 :t=49
			set a 43											# ...
			set t 49											# ...
		}														# 390 NEXT h
		newline													# 400 PRINT 
	}															# 420 NEXT w
	newline														# 430 PRINT 
	+= n 2
}

# EOF #